#ifndef DOUBLETRIGGERNOISEALGORITHM_H
#define DOUBLETRIGGERNOISEALGORITHM_H

#include "AnalysisAlgorithm.h"

namespace SctData {
    class DoubleTriggerNoiseTestResult;
}

namespace SctAnalysis {
    
class DoubleTriggerNoiseAlgorithm : public AnalysisAlgorithm {
public:
    /** 
	constructor 
     */
    DoubleTriggerNoiseAlgorithm(const TestData& testData, const string& moduleName, const AnalysisAlgorithm& alg) throw() : AnalysisAlgorithm(testData, moduleName, alg) {}
    /** 
	destructor 
     */
    virtual ~DoubleTriggerNoiseAlgorithm() throw();
    
    virtual void analyze();
    virtual void loadData();
    virtual bool canAnalyze() const;
    virtual shared_ptr<SctData::TestResult> createTestResult() const;
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(const TestData& testData, const string& moduleName) const throw();
 private:
    DoubleTriggerNoiseAlgorithm() {}
    unsigned short m_scanVariable; ///< pointer to variable type.
    static bool inMap;
};
}
#endif //#ifndef DOUBLETRIGGERNOISEALGORITHM_H
