#ifndef DEFAULTTEST_H
#define DEFAULTTEST_H

#include "../ipc/TestRequest.h"
#include "../ipc/ScanRequest.h"
#include "../ipc/CalibrationController.h"
#include "../ipc/CalibrationController.hh"
#include <CommonWithDsp/ABCD/ABCDscans.h>

using namespace SctCalibrationController::Ipc;

namespace SctCalibrationController {
namespace Scripts {
    
class DefaultTest : public TestRequestImpl {
public:	
      static Sct_CalibrationController::TestRequest_ptr instance(Sct_CalibrationController::ScanRequest_ptr s){
        static DefaultTest t;
	t.scan=Sct_CalibrationController::ScanRequest::_duplicate(s);
	return t._this();
      }
    
      virtual void startTestRealImpl(Sct_SctApi::SctApiIPC_ptr api,
			   string& name,
			   unsigned short& testVariable,
			   unsigned long& nScans,
			   vector<double>& testPoints) {
      name = "DefaultTest";
      testVariable = ST_ELAPSED;
      nScans = 1;
      testPoints.push_back(0);
    }
    
    virtual Sct_CalibrationController::ScanRequest_ptr getNextScanRealImpl(unsigned long index) {
      if (index == 0) {
        return Sct_CalibrationController::ScanRequest::_duplicate(scan);
      };
      return Sct_CalibrationController::ScanRequest::_nil();
    }
    
    virtual CORBA::Boolean canFeedbackRealImpl() {
	return false;
    }
    
    virtual void endTestRealImpl() {}
    
private:
    Sct_CalibrationController::ScanRequest_var scan;
};
}
}
#endif //DEFAULTTEST_H
