
#include <iostream>
#include <ipc/core.h>
#include <ipc/partition.h>
#include <pmg/pmg_initSync.h>
#include <unistd.h>
#include "Sct/ApplicationStartupDebugTools.h"
#include "SubscriptionManagerImpl.h"

using std::cout;
using std::cerr;
using std::endl;

int main(int argc, char * argv[]) {
  IPCCore::init(argc, argv);
  Sct::ApplicationStartupDebugTools::announceStartOfMain(argc, argv, __FILE__, __LINE__);
  
  IPCPartition p("SCT");
  if (!(p.isValid())) {
    cerr << "Could not get SCT partition.  Probably you have not started one, or even worse have not even started a root partition.  Try:\n     ipc_server &\n     sleep 2\n     ipc_server -p SCT &" << endl;
    return 1;
  };

  // now actually make the object that people will see via ipc methods:
  Sct::SubscriptionManagerImpl & subscriptionManager 
    = Sct::SubscriptionManagerImpl::instance();

  //subscriptionManager.startCatchingSignals();
  subscriptionManager.publish();

  pmg_initSync();

  while(true) {
    static unsigned int wait=1;
    cout << "Lurking for " << wait << " secs in " << __FILE__ << " line " << __LINE__ << endl;
    sleep(wait);
    wait*=2;
  };

};
