#include "TxCurrentTestResult.h"
#include "NullVariable.h"
#include "DefaultVariable.h"
#include <CommonWithDsp/ABCD/ABCDscans.h>

///@todo check that ST_COMPRESSION is really the right variable!

namespace SctData{
  
  const std::string rangedVectorName = "TxCurrentStreamResult";

  TxCurrentTestResult::TxCurrentTestResult() throw() : streamResults(rangedVectorName) {
    streamResults.resize(nLinkModule);
  }
    
  TxCurrentTestResult::TxCurrentTestResult(unsigned int runNumber, const string& moduleName) throw()
    : TestResult(runNumber, moduleName, NullVariable::instance(), 
                 *DefaultVariable::instance(ST_COMPRESSION)), 
      streamResults(rangedVectorName){
    streamResults.resize(nLinkModule);
  }
    
  TxCurrentTestResult::~TxCurrentTestResult() throw() {}

  string TxCurrentTestResult::getClassName() const throw(){
    return string("SctData::TxCurrentTestResult");
  }

  const TxCurrentTestResult::StreamResult& TxCurrentTestResult::getStreamResult(const unsigned index) const{
    return streamResults[index];
  }
    
  TxCurrentTestResult::StreamResult& TxCurrentTestResult::getStreamResult(const unsigned index){
    return streamResults[index];
  }

}
