#include "OpeSummaryTool.h"
#include "SctData/OpeResult.h"
#include "SummaryWriter.h"
#include "Sct/SctParameters.h"
#include <TH1.h>

#include <iomanip>

namespace SctData {
  namespace TestSummary{
    using namespace std;
    using namespace Sct;
    void OpeSummaryTool::write(const Serializable& t, ostream& out) const
      {
	const OpeResult& result  = dynamic_cast<const OpeResult&>(t);
	
	out << "#\n%OpeTool\n#"<<endl;
	out << "#\n#     MaxBadness      Threshold"<<endl;
	for (unsigned ichip=0; ichip<nChipModule; ++ichip){
	  const SctData::ChipOpeResult& c = result.getChipResult(ichip);
	  out << "#"<< SummaryWriter::getChipName(ichip) << endl;
	  out << "#   "
	      << std::setw(8) << c.badmax  << "   "
	      << std::setw(8) << c.threshold  << endl;
	}
      }
  }
}
