#This is an example setup script for both building from source and running the
#binary release.  

###############################
#Required variables for running
###############################


###### External Software ######

#Change this if you use gcc295
export CMTCONFIG=i686-rh73-gcc32-dbg


# Initialise the online software
export TDAQ_JAVA_HOME=/scratch/tdaq/online/j2sdk1.4.1_04 #Or set JAVA_HOME instead
export PATH=${TDAQ_JAVA_HOME}/bin:${PATH}
source /scratch/tdaq/online/online-00-21-02/installed/setup.sh
export PYTHONPATH=${TDAQ_INST_PATH}/${CMTCONFIG}/lib

# Setup the DataFlow software
export DF_INST_PATH=/scratch/tdaq/DataFlow/DF-00-09-01/installed
export PATH=${DF_INST_PATH}/${CMTCONFIG}/bin:${DF_INST_PATH}/share/bin:${PATH}
export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${DF_INST_PATH}/${CMTCONFIG}/lib

# Setup the PVSS libraries - may not be necessary
export PVSS_PATH=/atlas/daq/dcs/pvss2_v2.12
export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${PVSS_PATH}/bin
export PATH=${PATH}:${PVSS_PATH}/bin

#Setup ROOT
export ROOTSYS=/atlas/daq/root/gcc32/root
export PATH=${ROOTSYS}/bin:${PATH}
export LD_LIBRARY_PATH=${ROOTSYS}/lib:${LD_LIBRARY_PATH}

# Unfortunatley the online software people chose to bundle their own c++ library with their software and put it right at the beginning of LD_LIBRARY_PATH so that distros without the necessary c++ lib at CERN would still work.  However, this breaks everybody else's installation if they already have their own library which should be used in preference.  To get around this stupid stupid bug we need to kludge by adding the dir containing our libstdc++ (in our case /usr/local/lib) to the front of the search path:
export LD_LIBRARY_PATH=/usr/local/lib:${LD_LIBRARY_PATH}


######## Our Software #########

# The following should set SCT_DAQ_ROOT to the directory this script is run from
export SCT_DAQ_ROOT=/usr/local/atlas/SctRodDaq

#Set this to your rod configuration (or nothing for the test setup)
# export SCTDAQ_ROD_CONFIGURATION_PATH=${SCT_DAQ_ROOT}/installed/config/rods/exampleRod.xml

# Pick one of these (SCT_test will be set by default)
# export TDAQ_DB_DATA=${SCT_DAQ_ROOT}/installed/config/databases/SCT.data.xml
# export TDAQ_DB_DATA=${SCT_DAQ_ROOT}/installed/config/databases/SCT_nodcs.data.xml
# export TDAQ_DB_DATA=${SCT_DAQ_ROOT}/installed/config/databases/SCT_test.data.xml

#Only necessary if you share your online software installation
export TDAQ_IPC_INIT_REF=file:${SCT_DAQ_ROOT}/ipc.ref.file

# Directory to put IS proxy files
export SCT_SCRATCH_DIR=${SCT_DAQ_ROOT}/scratch

# Directory to permanently save data
export SCT_PERSISTENT_DIR=${SCT_DAQ_ROOT}/saved_data

# Hostname-qualified directory to permanently save data
export SCT_PERSISTENT_FQDN_DIR=`hostname --fqdn`:${SCT_PERSISTENT_DIR}

################################
#Required variables for building
################################

#Add junit.jar to CLASSPATH.  You can get junit.jar from www.junit.org
#export CLASSPATH=/atlas/daq/ext/junit.jar:$CLASSPATH

# Point to external programs 
export BOOSTDIR=/atlas/daq/ext/gcc32/boost-1.30.2
export NAGDIR=/atlas/daq/ext/Nag_C

# Point to external java jar files
export SCT_DAQ_EXT=/atlas/daq/ext

#####################################
#And finally, source the setup script
#####################################
cd ${SCT_DAQ_ROOT}
source ${SCT_DAQ_ROOT}/setup.sh
