/*
 * ModuleCommentPrompt.java
 *
 */

package DisplayGUI;
import java.util.Vector;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.io.*;
import Preferences.*;
import GuiComponents.System.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author  robinson
 */
public class ModuleCommentPrompt extends javax.swing.JFrame implements displayParams {
    private guiTableAdapter commentTable;
    private javax.swing.JTable table;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1,jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton okButton;
    
    private javax.swing.JTextArea comment;
    private javax.swing.JTextField username;

    private JMenu optionsMenu;

    private String defaultString="Enter your comment(s) here.";

    String serialNo=null;
    
    boolean resetFields=true;

    
    int updateIndex=-1;
    int deleteIndex=-1;
    int rowSelect=-1;
    
    /** Creates new form ModuleCommentPrompt */
    public ModuleCommentPrompt(String serialNo) {
	this.serialNo=serialNo;

	createMenus();
        initComponents();

        fillTable();

    }
    

    public int getNoRuns() {
         return commentTable.recordCount;
         }

    

    private void initComponents() {

        getContentPane().setBackground(backgroundColor);

        commentTable = new guiTableAdapter();
        table = new javax.swing.JTable(commentTable);
        jScrollPane1 = new javax.swing.JScrollPane(table);
        table.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);

        java.awt.GridBagConstraints gridBagConstraints;

//        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane(table);
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setText("Add Comments for "+serialNo);
        jLabel1.setFont(displayTitleFont);
        jLabel1.setForeground(darkBlueColor);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weighty = 0.1;
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel2.setText("Existing comments:");
        jLabel2.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        getContentPane().add(jLabel2, gridBagConstraints);

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        table.setBackground(new java.awt.Color(255, 255, 255));
	table.setFont(displayScaleFont);
        jScrollPane1.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jScrollPane1.setMaximumSize(new java.awt.Dimension(600, 300));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(50, 50));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(200, 100));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.3;
        getContentPane().add(jScrollPane1, gridBagConstraints);
	
	table.addMouseListener(new tableMouseAdapter());  // popup menu on second table only

	
        javax.swing.JLabel nll = new javax.swing.JLabel("Your name:");
        nll.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
	       gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(nll, gridBagConstraints);

        username = new javax.swing.JTextField(10);
        username.setFont(displayScaleFont);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.weighty = 0.1;
	       gridBagConstraints.weightx = 0.5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(username, gridBagConstraints);
	
	comment = new javax.swing.JTextArea();
	comment.setFont(displayScaleFont);
        comment.setLineWrap(true);
        comment.setWrapStyleWord(true);
        javax.swing.JScrollPane areaScrollPane = new javax.swing.JScrollPane(comment);
        areaScrollPane.setVerticalScrollBarPolicy(
                        javax.swing.JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        areaScrollPane.setPreferredSize(new java.awt.Dimension(600, 100));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.weighty = 0.3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.CENTER;
        getContentPane().add(areaScrollPane, gridBagConstraints);
        comment.setText(defaultString);
	comment.selectAll();
        comment.setCaretPosition(0);


        okButton.setText("Add Comment");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(okButton, gridBagConstraints);
        okButton.requestFocusInWindow();

        cancelButton.setText("Close");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weighty = 0.1;
        getContentPane().add(cancelButton, gridBagConstraints);


        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension WSize = getSize();
        setLocation((screenSize.width-(int)WSize.getWidth())/2,(screenSize.height-(int)WSize.getHeight())/2);
	
	show();
    }


    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOKActionPerformed
        updateComments();
	fillTable();
	if(resetFields) {
	   comment.setText(defaultString);
	   comment.selectAll();
	   comment.setCaretPosition(0);
	   }
	resetFields=true;
    }//GEN-LAST:event_bOKActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bOKActionPerformed
        closeDialog(null);
    }//GEN-LAST:event_bOKActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

 public void update(String serialNo) {
    this.serialNo=serialNo;
    jLabel1.setText("Add Comments for "+serialNo);
    fillTable();
    setVisible(true);
    }

  private void fillTable() {
       int cCount=0;
          Vector runVector = new Vector();
	  Vector theLine = new Vector();
	  theLine.addElement("Date");
	  theLine.addElement("User");
	  theLine.addElement("Comment(s)");
	  runVector.addElement(theLine);
	  theLine=null;

       try {

          File commentFile = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.WEB_LOOKUP_DIR)+"/ModuleComments",serialNo+".txt");
          Pattern iPattern = Pattern.compile("^INDEX=(\\d+);USER=(.*);DATE=(.*)$");

          if(commentFile.exists()) {
	      BufferedReader in = new BufferedReader(new FileReader(commentFile));
	      String line;
	      StringBuffer commentLine=null;
	      while((line=in.readLine())!=null) {
                Matcher matcher = iPattern.matcher(line);
		if(matcher.matches()) {
		   if(commentLine!=null) {
		       theLine.addElement(commentLine.toString());
		       runVector.addElement(theLine);
		       }
		   commentLine = new StringBuffer();
		   cCount++;
		   theLine=new Vector();
		   theLine.addElement(line.substring(matcher.start(3),matcher.end(3)));
		   theLine.addElement(line.substring(matcher.start(2),matcher.end(2)));
		   }
		else {
                   if(commentLine!=null) {
		      if(commentLine.length()!=0) commentLine.append("<br>");
		      commentLine.append(line);
		      }
		}
	      }

	      if(commentLine!=null && commentLine.length()>0) {
	         theLine.addElement(commentLine.toString());
	         runVector.addElement(theLine);
		 }

	      in.close();
	    }
        }catch(Exception ioE){System.err.println("Exception building table: "+ioE.toString());}

        commentTable.reTable(runVector);
	table.getColumnModel().getColumn(0).setPreferredWidth(30);
        table.getColumnModel().getColumn(1).setPreferredWidth(80);
	if(cCount==0) jLabel2.setText("There are no comments uploaded for this module yet:");
	else jLabel2.setText("There are "+Integer.toString(cCount)+" previously uploaded comments. Right mouse-click on a row for edit options:");



   }
   
   private void updateComments() {
       if(deleteIndex<0) {
          if(!username.getText().matches(".*[a-zA-Z0-9]+.*[\\s]*.*")) {
             javax.swing.JOptionPane.showMessageDialog(null,"Unvalid username. Please try again.");
	     resetFields=false;
	     return;
	     }
          if(!comment.getText().matches(".*[a-zA-Z0-9]+.*[\\s]*.*") || comment.getText().equals(defaultString)) {
             javax.swing.JOptionPane.showMessageDialog(null,"Unvalid comment. Please try again.");
	     resetFields=false;
	     return;
	     }
	   }
       try {
          File topDir = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.WEB_LOOKUP_DIR)+"/ModuleComments");
          if(!topDir.exists()) {
            javax.swing.JOptionPane.showMessageDialog(null,"Missing directory. Check that you have defined your 'book-keeping directory\nin your Preferences, and check it has a subdirectory named 'ModuleComments'");
	    return;
	    }
	  File commentFile = new File(topDir,serialNo+".txt");
          File oFile = new File(topDir,"sctGUI.txt");
	  Pattern iPattern = Pattern.compile("^INDEX=(\\d+);USER=(.*);DATE=(.*)$");

	  int count=0;
	      String theDate = guiUtilities.DaveUtils.getTodaysDate(false);
	      BufferedReader in = (commentFile.exists()) ? new BufferedReader(new FileReader(commentFile)) : null;
	      String line;
	      StringBuffer commentLine=null;
	      Map tempHash = new HashMap();
	      Map commentHash = new HashMap();
	      if(in!=null) {
	         while((line=in.readLine())!=null) {
		    System.out.println("line="+line);
		    Matcher matcher = iPattern.matcher(line);
		    if(matcher.matches()) {
		       if(tempHash.size()>0) {
		          tempHash.put("COMMENT",commentLine.toString());
			  System.out.println("adding key "+count);
		          commentHash.put(new Double(count),tempHash);
			  tempHash = new HashMap();
			  count++;
			  }
	               commentLine = new StringBuffer();
		       tempHash.put("USER",line.substring(matcher.start(2),matcher.end(2)));
		       tempHash.put("DATE",line.substring(matcher.start(3),matcher.end(3)));
		       }
		    else {
		       if(commentLine.length()!=0) commentLine.append("\n");
		       commentLine.append(line);
		       }
		    }
		 if(commentLine!=null) {
		    tempHash.put("COMMENT",commentLine.toString());
		    System.out.println("adding key "+count);
                    commentHash.put(new Double(count),tempHash);
		    }
	         in.close();
	      }
	//      System.out.println("now writing");
	      BufferedWriter out = new BufferedWriter(new FileWriter(oFile));

	      int outCount=0;
	      for(int i=0;i<commentHash.size();i++) {
	        Double key = new Double(i);
	        if(!commentHash.containsKey(key)) {
		   System.err.println("missing key "+key.toString());
		   continue;
		   }
	        if(i==deleteIndex) continue;
	        outCount++;
	        tempHash = (HashMap) commentHash.get(key);
	        String user = (String)tempHash.get("USER");
	        String date = (String)tempHash.get("DATE");
	        String cmt = (String)tempHash.get("COMMENT");
		if(updateIndex==i) out.write("INDEX="+Integer.toString(i)+";USER="+username.getText()+";DATE="+guiUtilities.DaveUtils.getTodaysDate(false));
		else out.write("INDEX="+Integer.toString(i)+";USER="+user+";DATE="+date);
		out.newLine();
		if(updateIndex==i) out.write(comment.getText());
		else out.write(cmt);
		out.newLine();
		}
	      if(updateIndex<0 && deleteIndex<0) {
	        outCount++;
	        out.write("INDEX="+Integer.toString(count)+";USER="+username.getText()+";DATE="+guiUtilities.DaveUtils.getTodaysDate(false));
	        out.newLine();
	        out.write(comment.getText());
	        out.newLine();
		}
	      out.close();
	      
	      if(outCount==0) commentFile.delete();
	      else {

                boolean deleted = (commentFile.exists()) ? commentFile.delete() : true;
                if(deleted) {
                    oFile.renameTo(commentFile);
                    if(commentFile.exists()) oFile.delete();
                    else javax.swing.JOptionPane.showMessageDialog(null,"Comment file lost!! Hopefully there is a backup at "+oFile.getAbsolutePath());
                    }
		}
	}catch(Exception e) {
           javax.swing.JOptionPane.showMessageDialog(null,"Exception saving comments: "+e.toString());
	   }
        updateIndex=-1;
	deleteIndex=-1;
	okButton.setText("Add Comment");
}



    class tableMouseAdapter extends java.awt.event.MouseAdapter {
            public void mouseClicked(java.awt.event.MouseEvent e) {
               switch(e.getModifiers()) {
                 case java.awt.event.InputEvent.BUTTON2_MASK:
                 case java.awt.event.InputEvent.BUTTON3_MASK:
                       rowSelect = table.rowAtPoint(new java.awt.Point(e.getX(),e.getY()));
                       table.getSelectionModel().setSelectionInterval(rowSelect,rowSelect);
                       javax.swing.JPopupMenu pMenu;
	               pMenu = optionsMenu.getPopupMenu();
                       pMenu.show(e.getComponent(),e.getX(),e.getY());
		       pMenu.setInvoker(optionsMenu);
                 default:
                 }
            }
    }


public void createMenus() {
    optionsMenu = new JMenu("Options");
    JMenuItem item = new JMenuItem("Edit...");
    item.setFont(displayScaleFont);
    item.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
		  username.setText((String)table.getValueAt(rowSelect,1));
		  String theComment = (String)table.getValueAt(rowSelect,2);
		  theComment =  theComment.replaceAll("<br>","\n");
		  comment.setText(theComment);
		  updateIndex=rowSelect;
                  okButton.setText("Change comment");
                     }
                });
    optionsMenu.add(item);
    item = new JMenuItem("Delete");
    item.setFont(displayScaleFont);
    item.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                  System.out.println("delete");
      //            int response = javax.swing.JOptionPane.showConfirmDialog(null,"Are you sure you want to delete the comment?",javax.swing.JOptionPane.YES_NO_OPTION,javax.swing.JOptionPane.QUESTION_MESSAGE);
      //            if(response==javax.swing.JOptionPane.NO_OPTION) return;
                  deleteIndex=rowSelect;
		  updateComments();
		  fillTable();
                     }
                });
    optionsMenu.add(item);
    }





    
    
}
