package SummaryReader;

public class LinkInfo {
    Double[][] linkData;
    int size=0;
    String[] paramNames;

    public LinkInfo(int size) {
        this.size=size;
	paramNames = new String[size];
        linkData = new Double[2][];
        for(int i=0;i<2;i++) {
	   linkData[i]=new Double[size];
	   for(int j=0;j<size;j++) linkData[i][j]=null;
	   }
        }
    public void addTitle(int index, String title) {
        paramNames[index]=new String(title);
	}
    public void add(int link, double value) {
       // assume only one data value per link
       linkData[link][0]=new Double(value);
       }

    public void add(int link, int index, double value) {
       linkData[link][index]=new Double(value);
       }
    public void add(int link, int index, String value) {
       try {
       linkData[link][index]=Double.valueOf(value);
       }catch(Exception e){System.err.println("SctGUI::LinkInfo exception - "+e.toString());}
       }
     public void add(int link, String value) {
       // assume only one data value per link
       try {
       linkData[link][0]=Double.valueOf(value);
       }catch(Exception e){}
       }

    public Double get(int link, int value) {
       if(link<0) return null;
       if(value>(size-1)) {
          return null;
	  }
       return linkData[link][value];
       }
     public Double get(int link) {
       // assume only one data word per link
       if(link<0) return null;
       return linkData[link][0];
       }
   public int getSize() {
       return size;
       }
   public String getSummaryTable() {
       StringBuffer table = new StringBuffer("<h3>Test Data</h3>\n");
       table.append("<table border=1>\n");
       table.append("<tr><td align=left>Parameter</td><td>Link 0</td><td>Link 1</td></tr>\n");
       for(int i=0;i<size;i++) {
          String title = (paramNames[i]==null) ? "Unknown" : paramNames[i];
	  table.append("<tr><td>"+title+"</td>");
	  for(int link=0;link<2;link++) {
	     String value = (linkData[link][i]==null) ? "Unknown" : linkData[link][i].toString();
	     table.append("<td align=left>"+ value +"</td>");
	     }
	  table.append("</tr>");
	  }
       table.append("</table>\n");
       return table.toString();
       }
}
